<script>




export default {

  // Определение структуры переменной student для хранения полей
  setup() {
    return {

      students: null,

      student: {
        firstName: null,
        sureName: null,
        middleName: null,
        birthDate: null,
        yearOfStudy: null,
        studentGroup: null
      },
    }
  },

  // Раздел методов
  methods: {

    // Метод сохранения студента 
    saveStudent() {
      console.log('Сохранение студента ==>', this.student.firstName, ' ' + this.student.middleName, ' ' + this.student.sureName);
      this.axios.post('http://localhost:7777/student', this.student).then((response) => {
        console.log('студент сохранен в БД ==>', response.data)

        // Отображение всплывающей подсказки для отображения ФИО студента
        this.$toast.add({
          severity: 'success',
          detail: 'Сохранение студента: ' + this.student.sureName,
          life: 3000
        })
      }).catch(error => {
        if (error.response) {
          console.log("Ошибка ответа сервера:", error.response.data)
          console.log("Статус ошибки ответа: ", error.response.status)
          console.log("Заголовки ошибки ответа: ", error.response.headers)

        } else if (error.request) {
          console.log("Не получен ответ на запрос: ", error.request)
          this.$toast.add({
            severity: 'error',
            detail: 'Ошибка сохранения студента',
            life: 3000,
          });
        } else {
          console.log('Ошибка отправки запроса: ', error.message);
        }
        if (error.config) {
          console.log('Ошибка конфигурации: ', error.config);
        }
      })
    },


    // Получение полного списка студентов 
    getAllStudents() {
      console.log('Получение полного списка студентов ...');

      this.axios.get('http://localhost:7777/student')
        .then(response => {
          console.log(' Получен список студентов => ', response.data)
          this.students = response.data
        })
        .catch(error => {
          if (error.response) {
            console.log("Ошибка ответа сервера:", error.response.data)
            console.log("Статус ошибки ответа: ", error.response.status)
            console.log("Заголовки ошибки ответа: ", error.response.headers)
          } else if (error.request) {
            console.log("Не получен ответ на запрос: ", error.request)
          } else {
            console.log('Ошибка отправки запроса: ', error.message);
          }
          if (error.config) {
            console.log('Ошибка конфигурации: ', error.config);
          }
        });
    },


    deleteStudent() {
      console.log('Сохранение студента ==>', '' + this.student.sureName)
    }
  },

  mounted() {
    // Инициализация  студента 
    this.student = {};
  }
}


</script>




<template>
  <Toast />

  <div class="container">

    <div>
      <span class="p-float-label">
        <InputText id="surename" type="text" v-model="student.sureName" style="width: 60%" />
        <label for="surename">Фамилия</label>
      </span>
      <br>

      <span class="p-float-label">
        <InputText id="firstName" type="text" v-model="student.firstName" style="width: 60% " />
        <label for="firstName">Имя</label>
      </span>
      <br>


      <span class="p-float-label">
        <InputText id="middleName" type="text" v-model="student.middleName" style="width: 60% " />
        <label for="middleName">Отчество</label>
      </span>
      <br>

      <Button class="form-button p-button-sm" label="Записать в базу данных" @click="saveStudent" />
      <br>
      <br>
      <Button @click="getAllStudents" icon="pi pi-check" label="Получить список студентов" />

      <br>
     
      
      <DataTable :value="students"> 
        <Column field="id" header="Номер"></Column>
        <Column field="firstName" header="Имя"></Column>
        <Column field="middleName" header="Отчество"></Column>
        <Column field="sureName" header="Фамилия"></Column>
        <Column field="middleName" header="Отчество"></Column>          
      </DataTable>


    </div>

  </div>
</template>



<style scoped>
.container {
  display: flex;
  align-items: center;
  justify-content: center;
  min-height: 100vh;
}
</style>
